       IDENTIFICATION DIVISION.
       PROGRAM-ID.    VRECEXC1.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2016 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
      *
      *****************************************************************
      * Source Member: VRECEXC1.CBL
      * Copy Files:    PASSRTN1.CPY
      *                ASCEBCB1.CPY
      * Calls to:      SIMOVREC
      *                SIMOBSIO
      *****************************************************************
      *
      *                   ************
      *                   * VRECEXE1 *
      *                   ********cmd*
      *                        *
      *                   ************
      *                   * if exist  *
      *                   ********stmt*
      *                        *
      *  ************     ************     ************
      *  * BSIODSN1 *-----* VRECEXC1 *-----* SQEDDV01 *
      *  ********dat*     ********cbl*     ********dat*
      *                        *   *
      *                        *   *       ************
      *                        *   *--call-* SIMOVREC *
      *                        *           ********cbl*
      *                        *             *
      *                        *             *       ************
      *                        *             *--call-* SIMOBSIO *
      *                        *                     ********cbl*
      *                   ************
      *                   *   EOJ    *
      *                   ************
      *
      *****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT SQEDDV01-FILE  ASSIGN to     SQEDDV01
                  ORGANIZATION is SEQUENTIAL
                  ACCESS MODE  is SEQUENTIAL
                  FILE STATUS  is SQEDDV01-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  SQEDDV01-FILE
           DATA RECORD    is SQEDDV01-RECORD
           RECORDING MODE is V
      *    ------------------------------------------------------------
      *    The following may need to be changed to match actual file.
           RECORD is VARYING in SIZE from 4 to 32760
           depending on SQEDDV01-LREC.

       01  SQEDDV01-RECORD.
           05  SQEDDV01-DATA-01  pic X(32760).
      *    The preceding may need to be changed to match actual file.
      *    ------------------------------------------------------------

       WORKING-STORAGE SECTION.
       01  SIM-TITLE.
           05  T1 pic X(11) value '* VRECEXC1 '.
           05  T2 pic X(34) value 'Variable Record Routine v01.00.00 '.
           05  T3 pic X(10) value ' v06.10.23'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* VRECEXC1 '.
           05  C2 pic X(20) value 'Copyright 1987-2016 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* VRECEXC1 '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* VRECEXC1 '.
           05  C2 pic X(32) value 'Please send all inquires or sugg'.
           05  C3 pic X(32) value 'estions to the helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.

       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* VRECEXC1 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

       01  SQEDDV01-STATUS.
           05  SQEDDV01-STATUS-L     pic X.
           05  SQEDDV01-STATUS-R     pic X.
       01  SQEDDV01-EOF              pic X       value 'N'.
       01  SQEDDV01-OPEN-FLAG        pic X       value 'C'.

       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  TWO-BYTES.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.
       01  TWO-BYTES-BINARY        redefines TWO-BYTES pic 9(4) comp.

       01  APPL-RESULT             pic S9(9)   comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

       01  SQEDDV01-LREC           pic 9(5)    comp    value 0.
       01  SQEDDV01-LREC-ALPHA     redefines   SQEDDV01-LREC.
           05  VREC-LEN-1          pic X(2).
           05  VREC-LEN-2          pic X(2).

       01  SQEDDV01-LBLK           pic 9(5)    comp    value 0.
       01  SQEDDV01-LBLK-ALPHA     redefines   SQEDDV01-LBLK.
           05  VBLK-LEN-1          pic X(2).
           05  VBLK-LEN-2          pic X(2).

       01  RECORD-LENGTH-DISPLAY.
           05  filler              pic X(15) value 'Record length: '.
           05  RECORD-LENGTH-VALUE pic 9(5)  value 0.

       01  RECORD-MIN-DISPLAY.
           05  filler              pic X(15) value 'Record MIN is: '.
           05  RECORD-MIN-VALUE    pic 9(4)  value 0.

       01  RECORD-MAX-DISPLAY.
           05  filler              pic X(15) value 'Record MAX is: '.
           05  RECORD-MAX-VALUE    pic 9(4)  value 0.

       01  BSIOREAD-TOTAL.
           05  filler      pic X(18)  value 'BSIOREAD count is '.
           05  BSIOREAD-COUNT      pic 9(7) value 0.

       01  BSIOBLOK-TOTAL.
           05  filler      pic X(18)  value 'BSIOBLOK count is '.
           05  BSIOBLOK-COUNT      pic 9(7) value 0.

       01  SQEDDV01-TOTAL.
           05  filler      pic X(18)  value 'SQEDDV01 count is '.
           05  SQEDDV01-COUNT      pic 9(7) value 0.

       COPY PASSVREC.

      *01  PASSVREC-AREA.
      *    05  VREC-REQUEST    pic X(8)        value 'GET     '.
      *    05  VREC-RESPOND    pic 9(4)        value 0.
      *    05  VREC-LENGTH     pic 9(5)        value 0.
      *    05  VREC-BUFFER     pic X(32760)    value SPACES.

      *****************************************************************
       PROCEDURE DIVISION.
           perform GET-STARTED
           perform SQEDDV01-OPEN
           add 80 to ZERO giving SQEDDV01-LREC
           perform until VREC-RESPOND not = ZERO
             call 'SIMOVREC' using PASSVREC-AREA
             if  VREC-RESPOND = ZERO
                 add  VREC-LENGTH to ZERO giving SQEDDV01-LREC
                 move VREC-BUFFER to SQEDDV01-RECORD
                 perform SQEDDV01-WRITE
             end-if
           end-perform

           perform SQEDDV01-CLOSE

           perform Z-THANK-YOU.
           GOBACK.

      *****************************************************************
       GET-STARTED.
           perform Z-POST-COPYRIGHT
           move 'GET     ' to VREC-REQUEST
           move ZERO       to VREC-RESPOND
           move ZERO       to VREC-LENGTH
           move SPACES     to VREC-BUFFER
           exit.

      *****************************************************************
      * I/O ROUTINES FOR SQEDDV01...                                  *
      *****************************************************************
       SQEDDV01-WRITE.
           if  SQEDDV01-OPEN-FLAG = 'C'
               perform SQEDDV01-OPEN
           end-if
           write SQEDDV01-RECORD
           if  SQEDDV01-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  SQEDDV01-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               move 'SQEDDV01-Failure-WRITE...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move SQEDDV01-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       SQEDDV01-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open output SQEDDV01-FILE
           if  SQEDDV01-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to SQEDDV01-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'SQEDDV01-Failure-OPEN...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move SQEDDV01-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       SQEDDV01-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close SQEDDV01-FILE
           if  SQEDDV01-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to SQEDDV01-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'SQEDDV01-Failure-CLOSE...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move SQEDDV01-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-Routines perform administrative tasks         *
      * for this program.                                             *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-CONSOLE-MESSAGE
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-CONSOLE-MESSAGE
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-CONSOLE-MESSAGE.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79)
           else
               display MESSAGE-BUFFER
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * two digits if the full two byte file status is numeric. If    *
      * second byte is non-numeric then it will be treated as a       *
      * binary number.                                                *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1    = '9'
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               display '* VRECEXC1 File-Status-' IO-STAT1 '/'
                       TWO-BYTES-BINARY
           else
               display '* VRECEXC1 File-Status-' IO-STATUS
           end-if
           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE
           display SIM-COPYRIGHT
           exit.

      *****************************************************************
       Z-THANK-YOU.
           display SIM-THANKS-01
           display SIM-THANKS-02
           exit.
      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
